<?
/*///////////////////////////////////////////////////////////////

	α׷	: RSSWriter.class
			: 0.9
	ۼ		: ջ
	ۼ	: 2004.10.20

	***  ***

	RSS(Real Simple Syndication,Rich Site Summary) Writer

	1. RSS 2.0 Specification 

	***   ***

/////////////////////////////////////////////////////////////////*/

class RSSWriter {
	var $charset = "euc-kr";
	var $title;
	var $link;
	var $description;
	var $ChannelOptionalElements = array();
	var $items = array();

	function RSSWriter($title,$link,$description = null,$ChannelOptionalElements = array()){
		$this->setChannel($title,$link,$description);
		$this->setChannelOptionalElements($ChannelOptionalElements);
	}

	function setCharset($charset){
		$this->charset = $charset;
	}

	function setChannel($title,$link,$description = ""){
		$this->title		= $title;
		$this->link			= $link;
		$this->description	= $description;
	}

	function setChannelOptionalElements($ChannelOptionalElements){
		$this->$ChannelOptionalElements = $ChannelOptionalElements;
	}

	function setTitle($title){
		$this->title = $title;
	}

	function setLink($link){
		$this->link = htmlspecialchars($link,ENT_COMPAT,'ISO-8859-1',true);
	}

	function setDescription($description){
		$this->description = $description;
	}

	function setLanguage($language){
		$this->ChannelOptionalElements["language"] = $language;
	}

	function setCopyright($copyright){
		$this->ChannelOptionalElements["copyright"] = $copyright;
	}

	function setManagingEditor($managingEditor){
		$this->ChannelOptionalElements["managingEditor"] = $managingEditor;
	}

	function setWebmaster($webMaster){
		$this->ChannelOptionalElements["webMaster"] = $webMaster;
	}

	// date format YYYY-MM-DD HH:mm:ss Ǵ YYYY-MM-DD ( : 2000-11-01 00:00:00)
	function setPubDate($pubDate){
		$this->ChannelOptionalElements["pubDate"]
			= sprintf("%s KST",date("Y-m-d H:i:s",$this->GetTimeStamp($pubDate)));
	}

	// date format YYYY-MM-DD HH:mm:ss Ǵ YYYY-MM-DD ( : 2000-11-01 00:00:00)
	function setLastBuildDate($lastBuildDate){
		$this->ChannelOptionalElements["lastBuildDate"]
			= sprintf("%s KST",date("Y-m-d H:i:s",$this->GetTimeStamp($lastBuildDate)));
	}

	function setCategory($category){
		$this->ChannelOptionalElements["category"] = $category;
	}

	function setGenerator($generator){
		$this->ChannelOptionalElements["generator"] = $generator;
	}

	function setDocs($docs){
		$this->ChannelOptionalElements["docs"] = $docs;
	}

	function setCloud($cloud){
		$this->ChannelOptionalElements["cloud"] = $cloud;
	}

	function setTtl($ttl){
		$this->ChannelOptionalElements["ttl"] = $ttl;
	}

	function setImage($image){
		$this->ChannelOptionalElements["image"] = $image;
	}

	function setRating($rating){
		$this->ChannelOptionalElements["rating"] = $rating;
	}

	function setTextInput($textInput){
		$this->ChannelOptionalElements["textInput"] = $textInput;
	}

	function setSkipHours($skipHours){
		$this->ChannelOptionalElements["skipHours"] = $skipHours;
	}

	function setSkipDays($skipDays){
		$this->ChannelOptionalElements["skipDays"] = $skipDays;
	}

	function setItem($title,$link,$description ="",$author = "",$pubDate ="",$category ="",
			$guid ="",$source ="",$comments ="",$enclosure =""){
		$item = array();
		$item["title"]		= $title;
		$item["link"]		= $link;
		$item["description"]	= $description;
		$item["author"]		= $author;
		$item["pubDate"]	= sprintf("%s KST",date("Y-m-d H:i:s",$this->GetTimeStamp($pubDate)));
		$item["category"]	= $category;
		$item["guid"]		= $guid;
		$item["source"]		= $source;
		$item["comments"]	= $comments;
		$item["enclosure"]	= $enclosure;

		$this->addItem($item);
	}

	function addItem($item){
		array_push($this->items,$item);
	}

	function println(){
		header("Content-type: text/xml");
		printf("<?xml version=\"1.0\" encoding=\"%s\" ?>\n",$this->charset);
		print("<rss xmlns:dc=\"http://purl.org/dc/elements/1.1/\" version=\"2.0\">\n");

		$this->printChannel();

		print("</rss>\n");
	}

	function printChannel(){
		print("<channel>\n");
		printf("<title>%s</title>\n",$this->title);
		printf("<link>%s</link>\n",$this->link);
		printf("<description>%s</description>\n",$this->description);

		while (list($name,$value) = each ($this->ChannelOptionalElements)) {
			printf("<%s>%s</%s>\n",$name,$value,$name);
		}

		$this->printItems();

		print("</channel>\n");
	}

	function printItems(){
		foreach($this->items as $item){
			print("<item>\n");
			while (list($name,$value) = each($item)) {
				if(!empty($item[$name])){
					$value = htmlspecialchars($value,ENT_COMPAT,'ISO-8859-1',true);
					printf("<%s>%s</%s>\n",$name,$value,$name);
				}
			}
			print("</item>\n");
		}
	}

	function GetTimeStamp($date)
	{
		/*  ó
		YYYY-MM-DD
		YYYY-MM-DD HH:mm:ss
		*/
		if (strlen($DATE) == 10) {
			$time = mktime(0,0,0,(int)substr($date,5,2),(int)substr($date,8,2),(int)substr($date,0,4));
		} else {
			$time = mktime((int)substr($date,11,2),(int)substr($date,14,2),
			(int)substr($date,17,2),(int)substr($date,5,2),(int)substr($date,8,2),(int)substr($date,0,4));
		}
		return $time;
	}

}
